#include "STKNachricht.h"

// Inhalt der STKNachricht Klasse aus STKNachricht.h
// Konstruktor
STKNachricht::STKNachricht( int ln, char *nachricht )
{
	verarbeitet = 0;
	spielZeit = *(double*)nachricht;
	this->ln = ln - 8;
	this->nachricht = new char[ this->ln ];
	for( int i = 0; i < this->ln; i++ )
		this->nachricht[ i ] = nachricht[ i + 8 ];
	ref = 1;
}

// Destruktor
STKNachricht::~STKNachricht()
{
	delete[] nachricht;
}

// nicht constant
void STKNachricht::setVerarbeitet()
{
	verarbeitet = 1;
}

// constant
bool STKNachricht::istVerarbeitet() const
{
	return verarbeitet;
}

double STKNachricht::getSpielZeit() const
{
	return spielZeit;
}

int STKNachricht::getLength() const
{
	return ln;
}

char *STKNachricht::getNachricht() const
{
	return nachricht;
}

// Reference Counting
STKNachricht *STKNachricht::getThis()
{
	ref++;
	return this;
}

STKNachricht *STKNachricht::release()
{
	ref--;
	if( !ref )
		delete this;
	return 0;
}