#ifndef StatistikRunde_H
#define StatistikRunde_H

#include <Bild.h>
#include <TextFeld.h>
#include "../SpielStatistikDaten.h"

using namespace Framework;

class StatistikRunde
{
private:
	BildZ *rundenBild;
	TextFeld *rundenNummer;
	TextFeld *rundenDauer;
	TextFeld *rundenSieger;
	TextFeld *spielfeldNutzung;
	TextFeld *verbleibend;
	Array< SSDRunde* > *daten;
	int auswahl;
	double verb;
	bool rend;
	int ref;

public:
	// Konstruktor
	StatistikRunde( Schrift *zSchrift, Array< SSDRunde* > *dat, bool historie = 0 );
	// Destruktor
	~StatistikRunde();
	// nicht constant
	void setRunde( int nummer );
	void doPublicMausEreignis( MausEreignis &me );
	bool tick( double tickVal );
	void render( Bild &zRObj );
	// constant
	bool mussVerlassen() const;
	// Reference Counting
	StatistikRunde *getThis();
	StatistikRunde *release();
};

#endif