#ifndef StatistikTabelle_H
#define StatistikTabelle_H

#include <Tabelle.h>
#include <AuswahlBox.h>
#include "../SpielStatistikDaten.h"

using namespace Framework;

class StatistikTabelle
{
private:
	Schrift *schrift;
	Array< SSDGesamtSpieler* > *ssdgs;
	Array< SSDGesamtTeam* > *ssdgt;
	Array< SSDRunde* > *ssdr;
	AuswahlBox *stAuswahl;
	AuswahlBox *grAuswahl;
	AuswahlBox *sortAuswahlGS;
	AuswahlBox *sortAuswahlGT;
	RCArray< AuswahlBox > *sortAuswahlRS;
	RCArray< AuswahlBox > *sortAuswahlRT;
	AuswahlBox *sortRichtungGS;
	AuswahlBox *sortRichtungGT;
	RCArray< AuswahlBox > *sortRichtungRS;
	RCArray< AuswahlBox > *sortRichtungRT;
	ObjTabelle *gesamtSpieler;
	ObjTabelle *gesamtTeam;
	RCArray< ObjTabelle > *rundeSpieler;
	RCArray< ObjTabelle > *rundeTeam;
	bool teamS;
	int rundeAusw;
	bool rend;
	int ref;
	// privat
	void tabelleLehren( ObjTabelle *zT, bool berschrift );
	void tabelleFllen( ObjTabelle *zT );

public:
	// Konstruktor
	StatistikTabelle( Array< SSDGesamtSpieler* > *ssdgs, Array< SSDGesamtTeam* > *ssdgt, Array< SSDRunde* > *ssdr, Schrift *zSchrift, Bildschirm *zScreen, bool historie = 0 );
	// Destruktor
	~StatistikTabelle();
	// nicht constant
	void doPublicMausEreignis( MausEreignis &me );
	bool tick( double tickVal );
	void render( Bild &zRObj );
	// constant
	int getRunde() const;
	// Reference Counting
	StatistikTabelle *getThis();
	StatistikTabelle *release();
};

#endif